'''
'''
try:
    from contextlib import ContextDecorator
except ImportError:
    from functools import wraps
    print('Are you from the past?')

    class ContextDecorator(object):

        def __call__(self, f):
            @wraps(f)
            def decorated(*args, **kwargs):
                with self:
                    return f(*args, **kwargs)
            return decorated


from texere import Texere


def activate(language):
    Texere().language = language


def get_language():
    return Texere().language


def get_lazy_text(key):
    return Texere().get_lazy_text(key)


def get_text(key):
    return Texere().get_text(key)


def init_texere(dirname, language):
    Texere(dirname, language)


class switch_language(ContextDecorator):

    def __init__(self, language):
        self._language = language

    def __enter__(self):
        self._texere_obj = Texere()
        self._old_language = self._texere_obj.language
        self._texere_obj.language = self._language
        return self

    def __exit__(self, *exc):
        self._texere_obj.language = self._old_language
        return False
