'''
'''
import json
import os.path


class LazyText(object):

    def __init__(self,  key):
        self._key = key

    def __str__(self):
        return Texere().get_text(self._key)


class Texere(object):

    '''
    '''

    _hive_mind = {}

    def __init__(self, dirname=None, language=None):
        self.__dict__ = Texere._hive_mind
        if '_init_was_here_' in self.__dict__:
            return
        assert dirname is not None
        assert language is not None
        self.__dict__['_init_was_here_'] = True
        self._dirname = dirname
        self.language = language
        self._dicts = {}

    def get_language(self):
        return self.language

    def get_lazy_text(self, key):
        return LazyText(key)

    def _get_text(self, key):
        lang = self.language
        if not lang in self._dicts:
            filename = self._get_filename()
            with open(filename) as f:
                data = json.loads(f.read())
                self._dicts[lang] = data
        try:
            return self._dicts[lang][key]
        except KeyError:
            return None

    def get_text(self, key):
        return self._get_text(key)

    def _get_filename(self):
        return os.path.join(self._dirname, '{}.json'.format(self.language))
